/* XXX: open iffparse and clipboard or so */

#include <devices/clipboard.h>
#include <proto/iffparse.h>


/* XXX: we should avoid using iffparse.. check netclip to see how to use the clipboard directly */

/*
 * copy_to_clip() is when the server sends us something, then
 * we should copy_from_clip() everytime we connect to a vnc server
 * and everytime there's something new in the clip
 */

ULONG copy_to_clip(STRPTR txt, ULONG len)
{
	struct IFFHandle *iffh;
	APTR clip;
	ULONG rc = FALSE;

	if (clip = OpenClipboard(PRIMARY_CLIP))
	{
		if (iffh = AllocIFF())
		{
			iffh->iff_Stream = (ULONG)clip;
			InitIFFasClip(iffh);

			if (OpenIFF(iffh, IFFF_WRITE) == 0)
			{
				if (PushChunk(iffh, MAKE_ID('F','T','X','T'), MAKE_ID('F','O','R','M'), IFFSIZE_UNKNOWN) != 0) goto fail;

				if (PushChunk(iffh, MAKE_ID('F','T','X','T'), MAKE_ID('C','H','R','S'), IFFSIZE_UNKNOWN) != 0) goto fail;

				if (WriteChunkBytes(iffh, txt, len) < 0) goto fail;

				if (PopChunk(iffh) != 0) goto fail;

				if (PopChunk(iffh) != 0) goto fail;

				rc = TRUE;

				fail:
				CloseIFF(iffh);
			}
			CloseClipboard(clip);
			FreeIFF(iffh);
		}
		else
		{
			CloseClipboard(clip);
		}
	}
	return (rc);
}

